package sherpa

// Errors generated by both clients and servers
const (
	SherpaBadFunction = "sherpa:badFunction" // Function does not exist at server.
)

// Errors generated by clients
const (
	SherpaBadResponse = "sherpa:badResponse" // Bad response from server, e.g. JSON response body could not be parsed.
	SherpaHTTPError   = "sherpa:http"        // Unexpected http response status code from server.
	SherpaNoAPI       = "sherpa:noAPI"       //  No API was found at this URL.
)

// Errors generated by servers
const (
	SherpaBadRequest = "sherpa:badRequest" // Error parsing JSON request body.
	SherpaBadParams  = "sherpa:badParams"  // Wrong number of parameters in function call.
)
